<template>
  <div v-if="editMode" tabindex='0' @mousedown="mouseDown" @click="selectZone" @mousemove="mouseMove" @focus="selectZone" v-mouseup-outside="unselectZone" v-blur-outside="unselectZone" class="editable-zone" :class="{ 'editable-active-zone': editableActiveZone == _uid }">

  {{ isDragging }}

    <slot></slot>
  </div>
  <div v-else><slot></slot></div>
</template>

<script>
// import _ from 'lodash'
// import ClickOutside from 'vue-click-outside'
import { mapActions, mapGetters } from 'vuex'

export default {
  directives: {
    // ClickOutside
  },

  props: {
    register: {
      type: Array,
      required: true
    },
    title: {
      type: String,
      required: true
    }
  },

  data () {
    return {
      isDragging: false,
      startingPos: []
    }
  },
  // watch: {
  // },

  // computed: {
  //   _ () { return _ },

  //   landingPage () {
  //     return this.$store.getters['landingpage/current'](this.$route.path) || {}
  //   }
  // },

  computed: {
    ...mapGetters({
      editableActiveZone: 'Y3TI/editableActiveZone',
      editMode: 'Y3TI/editMode'
    })
    // fields () {
    //   return _.map(this.register, (item) => {
    //     return {
    //       type: item.node ? item.node._type : null,
    //       key: item.node ? 'nid-' + item.node.nid : null,
    //       path: item.path
    //     }
    //   })
    // }

    // editablePath () {
    //   return [ this.node._type, 'nid-' + this.node.nid, ...this.path ]
    // },

    // textfieldData () {
    //   return this.getEditableData(this.editablePath) || _.get(this.node, this.path)
    // }
  },

  methods: {
    ...mapActions({
      setEditableActiveZone: 'Y3TI/setEditableActiveZone',
      unsetEditableActiveZone: 'Y3TI/unsetEditableActiveZone'
    }),

    mouseMove (e) {
      if (!(e.pageX === this.startingPos[0] && e.pageY === this.startingPos[1])) {
        this.isDragging = true
      }
    },

    mouseDown (e) {
      this.isDragging = false
      this.startingPos = [e.pageX, e.pageY]
    },

    selectZone (e) {
      if (!this.isDragging) {
        this.setEditableActiveZone({ data: { id: this._uid, fields: this.register, title: this.title } })
      }
      this.isDragging = false
      this.startingPos = []
    },

    unselectZone (e, el, extras) {
      // console.log('isDragging', this.isDragging)
      // if (!this.isDragging) {
      // console.log('onFoo')
      // console.log('fooEvent happened outside element:', el)
      // console.log('event:', e)

      const shortcutArea = document.getElementById('shortcut-area')
      const activeZone = document.getElementsByClassName('editable-active-zone') || []
      // console.log(e.target.parentNode.classList.contains('ck'))
      // if (e.target.classList.contains('ck') === false) {
      //   console.log('LAAAAAAA', e.target)
      // }
      if ((shortcutArea && shortcutArea.contains(e.target)) || (activeZone[0] && activeZone[0].contains(e.target)) || e.target.closest('.ck-balloon-panel')) {

      } else {
        this.unsetEditableActiveZone({ data: { id: this._uid } })
      }
      // if (!shortcutArea || !shortcutArea.contains(e.target) || !e.target.classList.contains('ck')) {
      //   // if (this.editableActiveZone !== this._uid) {
      //     this.unsetEditableActiveZone({ data: { id: this._uid } })
      //   }
      // }
      // }
    }
  //   ...mapActions({
  //     getAllChallengesCall: 'challenge/getAll',
  //     getAllLandingPagesCall: 'landingpage/getAll',
  //     getAllHomeSlidesCall: 'homeslide/getAll'
  //   }),

  //   async getAllChallenges () {
  //     await this.getAllChallengesCall({ options: { lazy: true } }).catch((err) => {
  //       console.log(err)
  //     })
  //   },

  //   async getAllLandingPages () {
  //     await this.getAllLandingPagesCall({ options: { lazy: true } }).catch((err) => {
  //       console.log(err)
  //     })
  //   },

  //   async getAllHomeSlides () {
  //     await this.getAllHomeSlidesCall({ options: { lazy: true } }).catch((err) => {
  //       console.log(err)
  //     })
  //   }
  }

  // created () {
  //   Promise.all([this.getAllChallenges(), this.getAllLandingPages(), this.getAllHomeSlides()]).then(() => {
  //     this.loadAnim()
  //   })
  // }
}
</script>

<style lang="scss" scoped>
  .editable-active-zone {
    outline: 2px solid black;
  }
</style>
